/******************************************************
Demo Anwendung fuer:
TLC5940: 16 Channel LED Driver w/DOT Correction & Grayscale PWM Control
http://focus.ti.com/docs/prod/folders/print/tlc5940.html

realesed under the GPL by Philipp Tiefenbacher
******************************************************/
#include "18f458.h"
//#include "16f877.h"

#device ADC=10
#include <STDLIB.H>
#include <math.h>
#fuses hs,nowdt,put,noprotect
#use delay(clock=20000000)	//20MHz, fuer delay()


// Names of the Input Pins of the LED Driver according to the datasheet
#define VPRG  PIN_D1  //27
#define SIN_PIN   PIN_D2  //26 in the DIP package
#define SCLK  PIN_D3  //25
#define XLAT  PIN_D4  //24
#define BLANK PIN_D5  //23
#define DCPRG PIN_D6  //19
#define GSCLK PIN_D7  //18

#define CHANNELS 64 // set this to a multiple of 16 if you cascade more than one TLC5940

#include "TLC5940.h"

#use rs232(baud=19200, xmit=PIN_C6, rcv=PIN_C7, Errors)


#define PHONE_GREEN_0 0
#define PHONE_GREEN_1 1
#define PHONE_GREEN_2 2
#define PHONE_GREEN_3 3

#define ATOM_RED_0 4
#define ATOM_RED_1 5
#define ATOM_RED_2 6
#define ATOM_RED_3 7
#define ATOM_RED_4 8
#define ATOM_RED_5 9

#define PHONE_BLUE_0 10
#define PHONE_BLUE_1 11
#define PHONE_BLUE_2 12













void all_on(int offset, long brightness) {
   int i;
  //red alle ein  und lansam abdunkeln    
   for (i = 0; i <16; i++) {
      dcs[offset + i] =  brightness;        
   }      
   
}









//so gehts :)
#define RED 16
#define GREEN 32
#define BLUE 48
#define SWIRL_SIZE 6

void main ()
{
   int led, i;
   int swirl[] = {4,8,5,9,7,6};
   initTLC5940();
   
   clearDisplay();

	while (1) {
      
      for (i = 0; i < 64; i++) {
         if (i == swirl[led]) {
            dcs[i] = 63;
         }
         else {
            dcs[i] = 0;
         }    
      }
      refreshDisplay();
      delay_ms(150);  
      led++;
      if (led >= SWIRL_SIZE) led = 0;
	}
}
