/******************************************************
Demo Anwendung fuer:
TLC5940: 16 Channel LED Driver w/DOT Correction & Grayscale PWM Control
http://focus.ti.com/docs/prod/folders/print/tlc5940.html

realesed under the GPL by Philipp Tiefenbacher
******************************************************/
#include "18f458.h"
//#include "16f877.h"

#device ADC=10
#include <STDLIB.H>
#include <math.h>
#fuses hs,nowdt,put,noprotect
#use delay(clock=20000000)	//20MHz, fuer delay()

#define PIN_CAPMEASURE PIN_C0

#define PIN_CAPMEASURE2_1 PIN_A1
#define PIN_CAPMEASURE2_2 PIN_A2



// Names of the Input Pins of the LED Driver according to the datasheet
 /*
#define VPRG  PIN_D0  //27
#define SIN_PIN   PIN_D1  //26 in the DIP package
#define SCLK  PIN_D2  //25
#define XLAT  PIN_D3  //24
#define BLANK PIN_D4  //23
#define DCPRG PIN_D5  //19
#define GSCLK PIN_D6  //18
#define XERR  PIN_D7  //16
//*/
///*
#define VPRG  PIN_D1  //27
#define SIN_PIN   PIN_D2  //26 in the DIP package
#define SCLK  PIN_D3  //25
#define XLAT  PIN_D4  //24
#define BLANK PIN_D5  //23
#define DCPRG PIN_D6  //19
#define GSCLK PIN_D7  //18
//#define XERR  PIN_D8  //16
//*/

#define CHANNELS 64 // set this to a multiple of 16 if you cascade more than one TLC5940

#include "TLC5940.h"

#use rs232(baud=19200, xmit=PIN_C6, rcv=PIN_C7, Errors)

void main ()
{
   int i, count;

   puts("hello!!");

   initTLC5940();

   count = 0;

	while (1) {
      for (i = 0; i < CHANNELS; i++) {
         if (i == (count & 63)) {
            dcs[i] = 63;
         }
         else {
            dcs[i] = 0;
         }
      }
      count++;
      refreshDisplay();
      puts("send!");
      delay_ms(200);
	}
}
